# Configuration file for the Sphinx documentation builder.
#
# For the full list of built-in configuration values, see the documentation:
# https://www.sphinx-doc.org/en/master/usage/configuration.html
import alabaster

html_theme_path = [alabaster.get_path()]
html_theme = 'alabaster'

project          = 'TFScript'
copyright        = '2022, Nicholas Hope and Paco Hope'
author           = 'Nicholas Hope and Paco Hope'
release          = '1.0'
extensions       = [
    'sphinx.ext.duration',
    'sphinx.ext.doctest',
    'sphinx.ext.autodoc',
    'sphinx.ext.autosummary',
    'sphinxarg.ext',
    'alabaster' ]
templates_path   = ['_templates']
exclude_patterns = []
html_static_path = ['_static']
html_theme_options = {
    'description'      : "Managing and simplifying TF2 scripts.",
    'fixed_sidebar'    : True,
    'show_powered_by'  : False,
}

import os
import sys
sys.path.append(os.path.abspath('../../src'))